<template>
  <div>
    <div id="review-container" class="review-container">
      <h2 class="mwe-rw-content-title">Review your recordings</h2>
      <div id="review-recordings" class="grid grid-cols-3">
        <div class="words-section col-span-3 md:col-span-1">
          <KeyboardShortcutsDialog :shortcuts="keyboardShortcuts" />
          <ItemList
            :words="recordedWords"
            :selected-index="currentRecording"
            class="mwe-rw-info"
            @update-current-word="updateCurrentRecording"
          >
            <template #word-status="statusProps">
              <CdxIcon v-if="uploadedRecordings.includes(statusProps.word)" :icon="cdxIconCheck" />
            </template>

            <template #word-selected="actionProps">
              <CdxCheckbox
                :disabled="hasSuccessfullyUploaded"
                @update:model-value="(value) => handleUpdate(value, actionProps.word.id)"
              />
            </template>
          </ItemList>
        </div>
        <div class="review-section col-span-3 md:col-span-2">
          <div id="mwe-rwp-info" class="mwe-rw-info">
            Check your records before starting their publication.
          </div>
          <div class="word-recording mx-4 my-5 sm:my-12 h-[180px] sm:h-[250px]">
            <div class="inner-container flex-col gap-y-7">
              <div class="flex gap-x-8 justify-center">
                <CdxButton
                  id="previous"
                  action="progressive"
                  class="button"
                  :disabled="currentRecording <= 0"
                  weight="quiet"
                  @click="moveBackward()"
                >
                  <CdxIcon :icon="cdxIconArrowPrevious" />
                </CdxButton>
                <p class="text-2xl font-medium">
                  {{ recordedWords.length && recordedWords[currentRecording].displayAs }}
                </p>
                <CdxButton
                  id="next"
                  action="progressive"
                  class="button"
                  :disabled="currentRecording + 1 >= availableRecordings.length"
                  weight="quiet"
                  @click="moveForward()"
                >
                  <CdxIcon :icon="cdxIconArrowNext" />
                </CdxButton>
              </div>
              <audio
                v-if="!isVideoRecording"
                controls="controls"
                :src="getAudioUrl()"
                class="scale-[.85] sm:scale-100"
              ></audio>
              <video v-else ref="video" class="my-3 h-[300px]" autoplay></video>
            </div>
          </div>

          <div class="mwe-rw-actions justify-center gap-x-5 px-6 sm:px-9">
            <div id="progress" class="progress w-[52vw] md:w-[30vw]"></div>
            <div class="mwe-rw-counter text-lg sm:text-xl">
              <span>{{ uploadedRecordings.length }} / {{ recordingsToUpload.length }}</span>
            </div>
          </div>
          <div class="play-all-controls">
            <CdxButton
              v-if="!isPlayingAll"
              action="progressive"
              weight="primary"
              @click="playAll"
            >
              Play All
            </CdxButton>
            <CdxButton
              v-else
              action="destructive"
              weight="primary"
              @click="stopPlayAll"
            >
              Stop
            </CdxButton>
          </div>
        </div>
        <CdxButton
          action="progressive"
          weight="primary"
          size="large"
          :disabled="!recordingsToUpload.length"
          @click="!hasSuccessfullyUploaded ? startPublishing() : recordMoreWords()"
        >
          {{ !hasSuccessfullyUploaded ? 'Publish!' : 'Record More words' }}
        </CdxButton>
      </div>

      <CdxMessage v-if="hasSuccessfullyUploaded" type="success" fade-in>
        <p><b>Recordings successfully stored!</b></p>
        <p>They are currently put on hold and will soon be uploaded to Wikimedia Commons.</p>
        <router-link :to="'/my-upload-batches/' + uploadBatch.id">
          Check out the progress here.
        </router-link>
      </CdxMessage>
    </div>
  </div>
</template>

<script setup>
import { CdxButton, CdxIcon, CdxMessage, CdxCheckbox } from '@wikimedia/codex'
import { cdxIconCheck, cdxIconArrowPrevious, cdxIconArrowNext } from '@wikimedia/codex-icons'
import { useRecordWizardStore } from '@/stores/recordwizard'
import { computed, onMounted, onUnmounted, ref, watch } from 'vue'
import axios from 'axios'
import ItemList from '@/components/ItemList.vue'
import KeyboardShortcutsDialog from '@/components/KeyboardShortcutsDialog.vue'
import { useRouter } from 'vue-router'
import { signLanguages } from '../utils/data'

const router = useRouter()

const emit = defineEmits([
  'canGoToNextStep',
  'canNotGoToNextStep',
  'togglePreviousBtn',
  'setCurrentStep',
])

const store = useRecordWizardStore()
const availableRecordings = ref(Object.keys(store.recordings))
const recordedWords = ref([])
availableRecordings.value.forEach((item) => {
  recordedWords.value.push(store.items.find((wordItem) => wordItem.id == item))
})
const isVideoRecording = Object.values(signLanguages).includes(store.selectedLanguageId)
const video = ref(null)

const currentRecording = ref(0)
const isPlayingAll = ref(false)
const playAllInterval = ref(null)

const updateCurrentRecording = (newRecording) => {
  console.log('Recording changed')
  currentRecording.value = newRecording
  playRecording()
}
const recordingsToUpload = ref([])
const uploadedRecordings = ref([])
const hasSuccessfullyUploaded = computed(() =>
  recordingsToUpload.value.length
    ? uploadedRecordings.value.length >= recordingsToUpload.value.length
    : false,
)

const handleUpdate = (value, wordId) => {
  if (value) {
    recordingsToUpload.value = [...recordingsToUpload.value, wordId]
  } else {
    recordingsToUpload.value = recordingsToUpload.value.filter((item) => item !== word)
  }
}
const uploadBatch = ref({})

const keyboardShortcuts = [
  {
    key: '←',
    description: 'Previous Word',
  },
  {
    key: '→',
    description: 'Next Word',
  },
  {
    key: 'space',
    long: true,
    description: 'Play Selected Recording',
  },
]

function playRecording() {
  if (!isPlayingAll.value) {
    playCurrentRecording()
  }
}
function getAudioUrl() {
  return URL.createObjectURL(store.recordings[availableRecordings.value[currentRecording.value]])
}
async function startPublishing() {
  // Create an upload batch
  const requestConfig = {
    withCredentials: true,
    withXSRFToken: true,
  }

  uploadBatch.value = await axios
    .post(
      '/upload-batches/my',
      {
        locutor: store.selectedLocutorId,
        language_qid: store.selectedLanguageId,
      },
      requestConfig,
    )
    .then((response) => response.data)
    .catch((error) => {
      console.log(error)
      if (error.response) {
        // Got a response but not 200 OK
        // 400 bad request
        // 403 with CSRF issue?
        // TODO
      } else if (error.request) {
        // Could not get a response, probably a network error
        // TODO
      }
    })

  console.log(uploadBatch.value)
  // handle error if upload batch is not defined (due to error before)
  const progressContainer = document.getElementById('progress')
  const progressValueElement = document.createElement('div')
  progressValueElement.classList.add('progress-value')
  progressContainer.appendChild(progressValueElement)

  for (const word of recordingsToUpload.value) {
    const recording = await axios
      .postForm(
        '/upload-batches/my/' + uploadBatch.value.id + '/recordings',
        {
          file: store.recordings[word],
          transcription: word,
        },
        requestConfig,
      )
      .then((response) => response.data)
      .catch((error) => {
        console.log(error)
        if (error.response) {
          // Got a response but not 200 OK
          // 403 with CSRF issue?
          // TODO
        } else if (error.request) {
          // Could not get a response, probably a network error
          // TODO
        }
      })
    console.log(recording)
    if (recording) {
      uploadedRecordings.value.push(word)
    }
  }

  emit('togglePreviousBtn')
}

const recordMoreWords = () => {
  store.items = store.items.filter((word) => !recordingsToUpload.value.includes(word))
  store.shareableListId = undefined
  recordingsToUpload.value.forEach((item) => delete store.recordings[item])
  router.push({ name: 'record-wizard.word-list' })
  emit('setCurrentStep', 3)
  emit('togglePreviousBtn')
  if (!store.items.length) emit('canNotGoToNextStep')
}

watch(currentRecording, () => {
  if (currentRecording.value + 1 >= availableRecordings.value.length) {
    emit('canGoToNextStep')
  }
})

function moveForward() {
  if (currentRecording.value + 1 >= availableRecordings.value.length) return
  currentRecording.value++
}

function moveBackward() {
  if (currentRecording.value <= 0) return
  currentRecording.value--
}

function handleShortcuts(event) {
  // Do not trigger those events when the user is focusing an input
  if (event.target.nodeName === 'INPUT' || event.target.nodeName === 'BUTTON') {
    return
  }

  switch (event.which) {
    case 37: // left
    case 38: // up
      moveBackward()
      break

    case 39: // right
    case 40: // down
      moveForward()
      break

    case 32: // space bar
      playRecording()
      break

    default:
      return
  }
  event.preventDefault()
}

onMounted(() => {
  addEventListener('keydown', handleShortcuts)
})

onUnmounted(() => {
  removeEventListener('keydown', handleShortcuts)
})

function playAll() {
  isPlayingAll.value = true
  currentRecording.value = 0
  playCurrentRecording()
  playAllInterval.value = setInterval(() => {
    if (currentRecording.value < availableRecordings.value.length - 1) {
      currentRecording.value++
      playCurrentRecording()
    } else {
      stopPlayAll()
    }
  }, 1000) // site where interval between can be modified right now : 1s
}

function stopPlayAll() {
  isPlayingAll.value = false
  clearInterval(playAllInterval.value)
}

function playCurrentRecording() {
  const url = URL.createObjectURL(
    store.recordings[availableRecordings.value[currentRecording.value]]
  )
  if (isVideoRecording) {
    video.value.src = url
    video.value.play()
  } else {
    const audioNode = new Audio(url)
    audioNode.play()
  }
}
</script>

<style>
.progress {
  border: 1px solid rgba(156, 173, 210, 0.5);
  justify-content: flex-start;
  border-radius: 100px;
  align-items: center;
  position: relative;
  display: flex;
  height: 20px;
}

.progress-value {
  animation: load 3s normal forwards;
  box-shadow: 0 10px 40px -10px #fff;
  border: 1px solid rgba(156, 173, 210, 0.5);

  border-radius: 100px;
  background: blue;
  height: 20px;
  width: 300px;
}

@keyframes load {
  0% {
    width: 0;
  }
  100% {
    width: 100%;
  }
}
#review-recordings {
  padding: 0;
}

#previous {
  background-color: #f8f7f8;
  cursor: pointer;
  font-weight: bold;
}
#next {
  background-color: #f8f7f8;
  font-weight: bold;
  cursor: pointer;
}
.inner-container {
  display: flex;
  justify-content: center;
  align-items: center;
  gap: 20px;
}
.word-recording {
  background-color: #f8f9fa;
  display: flex;
  align-items: center;
  justify-content: center;
}

#review-container {
  min-height: 200px;
  background-color: #ffffff;
  border-radius: 12px;
  margin-bottom: 16px;
}
.review-section {
  display: flex;
  gap: 25px;
  padding: 0 !important;
  flex-direction: column;
}
.words-section {
  border-right: 1px solid rgba(156, 173, 210, 0.5);
}
.mwe-rw-info {
  margin: 25px 35px 0px 20px;
  line-height: 20px;
  color: #9daed2;
  text-align: center;
}
.mwe-rw-actions {
  display: flex;
  align-items: center;
  height: 100px;
  border-top: 1px solid rgba(156, 173, 210, 0.5);
}
.mwe-rw-counter {
  position: relative;
  font-weight: bolder;
  letter-spacing: 0.5px;
  color: #222222;
}
.mwe-rw-content-title {
  display: flex;
  box-sizing: border-box;
  padding-top: 25px;
  height: 74px;
  width: 100%;
  border-bottom: 1px solid #dadada;
}
.review-container > *,
.review-section,
.buttons {
  padding-left: 35px;
  padding-right: 35px;
}
.buttons {
  display: flex;
  justify-content: center;
  gap: 20px;
}
.play-all-controls {
  display: flex;
  justify-content: center;
  margin-top: 20px;
}
</style>

